Make Logger rotate and split logfiles

2009-12-14 13:40 - Felix Schäfer

Status: Closed Start date: 2009-12-14

Priority: Low Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Fixed   

Description

This issue has already been discussed in #3388 (well, obviously more rejected than discussed), but I will repeat this feature request

nonetheless, because Logger#new can do that on its own. This would require only a one-line addition to 

source:/trunk/config/environments/production.rb, for example:

config.logger = Logger.new(config.log_path, 7, 1048576)

History

#1 - 2009-12-24 19:58 - Eric Davis

How would this work in a multi process deployment where there are several processes writing to the log file at once?

#2 - 2009-12-24 20:52 - Felix Schäfer

Well, I just assumed that as Logger is part of stdlib it would take care of it, but I went digging in the ruby core_ext directory, and found logger.rb and

monitor.rb. Short version: Logger uses a mutex through MonitorMixin. Long version: take a look at Logger#initialize (line 256) and LogDevice (line

473) in logger.rb and MonitorMixin (basically the whole file) in monitor.rb (lines apply for the OS X.6 version of 1.8.7, don't know how "vanilla" it is).

#3 - 2010-09-18 13:46 - Felix Schäfer

- Status changed from New to Closed

- Resolution set to Fixed

Some docs have been added in r4096 and on RedmineInstall.
https://www.redmine.org/issues/3388
http://www.ruby-doc.org/stdlib/libdoc/logger/rdoc/classes/Logger.html#M000398
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/config/environments/production.rb
https://www.redmine.org/projects/redmine/repository/svn/revisions/4096
https://www.redmine.org/projects/redmine/wiki/RedmineInstall
http://www.tcpdf.org

